component-section
  div(slot='title') HandsOn
  component-section
    div(slot='title') Vertaal App
    component-section
      div(slot='title') Inleiding
      p
        | Je werkt voor een softwarebedrijf die op maat gemaakte mobiele applicaties ontwikkeld voor haar klanten.
        | Een klant heeft opdracht gegeven om de Vertaal-webapplicatie uit te breiden met een mobiele versie.
      div
        h3 Requirements:
        ul
          li
            | Op de bestaande server draait al de vertaalservice als REST API die JSON-objecten verwerkt.
          li
            | Selecteer bron en doel taal van een lijst van beschikbare talen, aangeleverd door de REST API.
          li Vertaal woorden van de bron- naar doeltaal
          li
            | De app mag alleen werken op toestellen met het Android besturingssysteem.
            | Er is geen uitbreiding gepland.
          li Het is toegestaan dat de app niet werkt als er geen internetverbinding is.
          li
            | Vanwege concurrentie is het van het grootste belang dat de app zo snel mogelijk voor de markt beschikbaar komt.
    component-section
      div(slot='title') Opdracht
      div
        | Werk in ongeveer 15 minuten onderstaande punten uit in een groep van 3-5 studenten.
        ul
          li Ontwikkel een overal visie van het systeem.
          li Maak een sketch van de architectuur op papier of whiteboard.
          li Geef duidelijk aan welke punten later moeten worden uitgewerkt.
          li Geef duidelijk aan wat de tekening niet behandeld.
          li
            | Gebruik de tekening om de
            |
            strong besluiten
            |
            | te beargumenteren die nodig zijn om het systeem te maken (algehele structuur, subsystemen, technologieën, ...).
          li Het is niet nodig om modelleertechnieken te gebruiken, zoals UML.
          li
            | Maak redelijke aannames bij onzekerheden in de requirements en documenteer deze.
          li Geef een korte presentatie van drie minuten over de gekozen architectuur.
  component-section
    div(slot='title') Smart Mobility
    component-section
      div(slot='title') Inleiding
      p
        | We are heading towards a new age in transportation: the era of smart mobility.
        | The arrival of on-demand ride services like
        |
        a(href='https://www.uber.com') Uber
        |
        | and real-time ridesharing services such as
        |
        a(href='https://flinc.org') Flinc
        |
        | and
        |
        a(href='https://zimride.com/') Zimride
        |
        | are all changing how people get around.
        | Commuters no longer need to own a car to have one at their disposal.
        | They don’t have to pre-arrange carpools to share a ride with others headed in the same direction.
        | They needn’t wait for a ride home when it’s pouring down rain and train tracks are disrupted.
        | Smart mobility solutions are especially beneficial for universities.
        | They offer students and employees a way to save time and money, to meet new people and provide a comfortable solution for traveling home for the holidays or weekend trips.
        | They also offer unique possibilities for students who live outside of urban areas, as they no longer need to put up with longer travel time, poor train facilities or the high cost of own cars.
        | Additionally, such solutions have a number of benefits for the universities.
        | They reduce campus traffic, infrastructure costs and parking congestion, reduce carbon footprint, improve sustainability and finally foster a stronger sense of community non only within faculties, but for the entire campus.
    component-section
      div(slot='title') Your Project
      p
        | You work together with your fellow students as a startup company that develops a smart mobility solution for the HAN University.
        | The goal of the project is to provide a facility for students and HAN employees to efficiently organize their daily travels from, to and between HAN campuses, thereby making use of efficient ride sharing, train and bus facilities.
        | The envisioned software system is roughly comparable to the service provided by Zimride for organizations.
      p
        em
          | Unfortunately, Zimride has been stopped but we can still get an idea how it worked.
      div
        strong The basis flow of use is as follows:
        ol
          li
            | Drivers register their planned trips including source, destination, planned time of departure, planned time of arrival, and free seats for each of the trips.
          li
            | A passenger specifies a planned trip including source, destination, and planned time of arrival
          li
            | The system searches possible matches in planned trips of drivers; this list covers partial rides, as well.
            | This means that the passenger’s desired ride is included in the driver’s ride, or the destination is not reached exactly, but instead a public transportation station closer to the location is reached.
          li
            | The system proposes public transportation options to fill each gap in each of the candidate travel plans.
            | This is also the case when no shared trips could be identified at all.
          li
            | The passenger contacts the respective driver and both agree on the shared trip including a price for the ride.
      div
        h3 Features
        strong The software system you come up with needs to entail the following features:
        ol
          li Support shared rides with cars, included partially shared trips.
          li Include public transportation (train, bus, ...) tracks in travel plans.
          li
            | Provide smart proposals for travel plans by using rooster information from the HAN and personal online agendas.
            | An example could be: a user logs in on Sunday, the system presents candidate travel plans for the upcoming week based on the SAS rooster and the home location of the passenger.
          li
            | Once a trip arrangement has been made, show real-time position of the vehicle to all passengers who will be picked up during the trip including estimated time of arrival (ETA) at the passenger pickup-location and the ETA at the passenger’s final destination.
          li
            | Provide a dashboard for platform administration showing application quality-of-service parameters (e.g., number of requests/s, response time, response time variation, exceptions &amp; errors).
          li
            | Provide a client application for Android (can be cross-platform as well) and a responsive web application.
          li Personal information of registered users needs to remain safe.
          li
            | Integrate with navigation system software to provide maximum usability to the driver.
          li
            | Provide ways to directly import travel plans in personal online agendas.
            | As part of this feature, the system creates agenda items for pick-ups and for planned rides using public transportation.
          li
            | Although the system needs to be streamlined for the HAN, make sure it is adaptable to other universities in the future.
          li
            | Make sure the system can grow with respect to number of registered and concurrent users in the future.
          li
            | Provide a visualization of all locations that can be reached within the network of registered travel plans taking into account shared rides only (all source, destination, and pickup locations).
          li
            | Allow passengers to specify arbitrary constraints (as text) on which transportation options are acceptable and use these constraints to filter possible trips.
            | For example: a trip must contain no more than 2 car segments with a joint duration of at most 30 minutes.
    component-section
      div(slot='title') Opdracht
      div
        | In the following 45 minutes, work in groups of 3-5 people.
        ul
          li Develop an overall vision of the system
          li Sketch the architecture on a paper/whiteboard
          li Make explicit which parts must be worked out later
          li Make explicit what the model does NOT cover
          li
            | Use the sketch to reason about decisions you need to make to realize the system (overall structure, subsystems, technologies, ...)
          li The use of modeling languages (e.g., UML) is not required
          li
            | When having uncertainties about requirements, make reasonable assumptions and document them
          li
            | Prepare for a short (3 min) presentation of your main ideas (using paper sketches, no slides)
      div
        strong Individual
        ul
          li Take a picture of your design sheets
          li
            | Reflect on the differences between the first and the second case with respect to software architectural design
          li
            | What made reasoning about the first case easier than reasoning about the second case?
          li
            | Name the three requirements that were the most important inputs for architectural design and describe why?
          li What aspects are architectural design, what aspects are more detailed design?
  component-section
    div(slot='title') Software Trendanalyse Dashboard
    component-section
      div(slot='title') Inleiding
      p.bron
        | Om de nieuwste IT opleidingen aan te kunnen bieden moet HAN - AIM up-to-date zijn met de laatste trends en onderwerpen.
        | Als een nieuw framework populair wordt, is het belangrijk dat het docententeam hierop kan inspelen.
        | Dit kan HAN - AIM doen door nieuwe (hybride) docenten aan te nemen, huidige docenten bij te scholen of medewerkers in te zetten die ervaring hebben met deze laatste trends en onderwerpen.
      div
        | Om deze trends en onderwerpen inzichtelijk te hebben wil HAN - AIM de laatste opkomende technologieën zichtbaar hebben in een IT Trendanalyse dashboard. Dit dashboard verzameld en combineert data uit verschillende datastromen.
        | Deze datastromen bestaan uit:
        ul
          li Interne data, zoals ervaring met technieken uit Curriculum Vitae’s van docenten.
          li
            | Feedback vanuit de werkveldcommissie, die afgestudeerde studenten willen met zo veel mogelijk kennis van bestaande technologieën.
          li Externe data van StackOverflow trendrapporten.
        | Met deze datastromen wordt een dashboard gecreeërd waar docenten en medewerkers de nieuwe trends overzichtelijk kunnen zien.
        | Om dit dashboard te bouwen is het belangrijk om een weloverwogen keuze te maken over de structuur van de applicatie.
      component-section
        div(slot='title') Doel
        component-exercise
          p
            | Om dit Trendanalyse Dashboard te kunnen realiseren wordt het jullie opdracht een passende architectuur te bepalen in lijn met de visie van de Product Owner.
    component-section
      div(slot='title') Opdrachten
      component-section
        div(slot='title') Context
        p
          | Het Software Trendanalyse Dashboard dat gebouwd moet worden, moet aan functionele en non-functionele eisen voldoen.
          | Om te bepalen wat de applicatie functioneel en non-functioneel moet kunnen, vinden er interviews plaats met de Product Owner.
      component-section
        div(slot='title') Probleemstelling
        p
          | Het is niet duidelijk welk software architectuur patroon het beste aansluit op de karakteristieken van het Software Trendanalyse dashboard.
      component-section
        div(slot='title') Doelstelling
        p
          | Het doel van dit onderzoek is het vinden van een software architectuur patroon dat het meest passend is bij de opgestelde karakteristieken.
          | Zo kan er een weloverwogen start gemaakt worden aan de bouw van de applicatie.
      component-section
        div(slot='title') Vereisten
        p
          | De applicatie moet altijd beschikbaar zijn, zodat te allen tijde te zien is of er een nieuwe trends zijn.
          | Als de applicatie down is kunnen de nieuwe trends niet bekeken worden en dat is niet wenselijk.
        p
          | In de nabije toekomst is het mogelijk dat de applicatie gebruikt gaat worden door alle docenten van de HAN en meer dan alleen IT trends toont.
          | De applicatie zal zelden deze hoeveelheid gebruikers tegelijkertijd hebben.
          | Hiertoe dient de applicatie schaalbaar te zijn, zodat alleen de benodigde resources ingenomen worden.
          | Wanneer deze resources wel nodig zijn kunnen ze extra ingezet worden zonder problemen.
        p
          | In de toekomst zullen ook andere bronnen noodzakelijk zijn.
          | Daarom moet het mogelijk moet zijn om extra databronnen toe te voegen aan de applicatie.
        p
          | Het testen van software verhoogt de kwaliteit (Bass et al., 2021).
          | Daarom moet het met de gekozen architectuur mogelijk zijn om alle componenten los te testen.
          | Daarnaast is het belangrijk dat er
          |
          em minimaal
          |
          | 80% code coverage is over de gehele codebase.
          | Om de losse componenten te kunnen testen moet er dus zo min mogelijk afhankelijkheden zijn tussen de componenten.
        p
          | De te bouwen software oplossing dient te voldoen aan een van de gebruikte frameworks binnen HAN - AIM zodat de applicatie ook in de toekomst kan worden onderhouden door studenten.
          | Dat betekent dat alleen .NET Framework of het Java framework of een combinatie hiervan mogelijk zijn.
        component-exercise
          p
            | Bovenstaande geeft een idee van de vereisten, dit is echter niet voldoende.
            | Aan jullie de opdracht om een gedetailleerd beeld van de vereisten op te leveren aan de Product Owner.
          p
            | ✋
            em Probeer het eerst zonder naar alle vereisten te kijken!
      component-section
        div(slot='title') Programma van Vereisten
        p
          | Onderstaande vereisten zijn tot stand gekomen door gesprekken met diverse stakeholders.
          | Tijdens de les in OW-4
          |
          a(href='SKA/#sec_2.4') Architecture design cycle
          |
          | zullen deze vereisten verder worden behandeld.
        p
          | ✋ Let op dat niet alle functionele eisen als een Quality Attribute kunnen worden beschouwd.
        component-exercise
          p
            | Probeer voor te bedenken welke acties je zou kunnen uitvoeren om tot onderstaande lijst te komen?
        component-section
          div(slot='title') Functionele Eisen
          p
            | Deze functionele eisen worden opgenomen in user stories.
            | Wanneer deze userstories dan opgeleverd worden moet er ook aan de eisen voldaan zijn (DoD).
            | Dit wordt gecontroleerd door de Product Owner.
          p
          table#table_funceisen
            caption
              | Functionele eisen
            thead
              tr
                th(scope='col') Omschrijving
                th(scope='col') Belang
            tbody
              tr
                td
                  | De front-end van de applicatie laat nader te definiëren grafieken zien met daarin de meest (opkomende) technieken.
                td Hoog
              tr
                td De front-end van de applicatie laat in een menu de databronnen zien.
                td Hoog
              tr
                td
                  | De front-end van de applicatie laat per databron een grafiek of grafieken zien met de bijbehorende keywords per jaar.
                td Hoog
              tr
                td
                  | De applicatie maakt het mogelijk om nieuwe databronnen toe te voegen (bijvoorbeeld van Gartner).
                td Hoog
              tr
                td De applicatie kan verschillende bestandsformaten ophalen via een API.
                td Hoog
              tr
                td
                  | De applicatie kan verschillende bestandsformaten (Excel, CSV, JSON) verwerken via een API met een POST-request.
                td Hoog
              tr
                td Gebruikers kunnen in de applicatie inloggen met HAN credentials
                td Hoog
              tr
                td
                  | Gebruikers kunnen op opkomende technologieën klikken om informatie daarover op te zoeken.
                td Laag
              tr
                td
                  | Gebruikers kunnen grafieken filteren op datastroom.
                  |
                  em Bijvoorbeeld: datastroom=Klant aanvragen, datastroom=CV’s medewerkers, datastroom=Rapporten trendwatchers.
                td Middel
              tr
                td
                  | Gebruikers kunnen grafieken filteren op categorie.
                  |
                  em Bijvoorbeeld: ICT, Finance of HR
                td Middel
              tr
                td
                  | Gebruikers kunnen grafieken filteren op tijdsperiode.
                  |
                  em Bijvoorbeeld: dag, maand, jaar
                td Middel
              tr
                td HAN Admins kunnen nieuwe gebruikers toevoegen aan de applicatie.
                td Hoog
              tr
                td
                  | Admins kunnen rollen toekennen aan gebruikers.
                  |
                  em Bijvoorbeeld: Beheerder of gebruiker
                td Middel
              tr
                td
                  | De gebruiker kan de front-end van de applicatie alleen bekijken als deze is ingelogd.
                td Hoog
              tr
                td De applicatie haalt elk uur alle data op van de interne aanvragen binnen.
                td Middel
        component-section
          div(slot='title') Operationele Eisen
          p
          p
          table#table_opereisen
            caption
              | Operationele Eisen
            thead
              tr
                th(scope='col') Omschrijving
                th(scope='col') Belang
            tbody
              tr
                td
                  | De applicatie dient 95% beschikbaarheid te hebben 24/7 wanneer de applicatie opgeleverd is.
                td Hoog
              tr
                td
                  | De applicatie bevat een 80% code coverage percentage voordat een story wordt opgeleverd
                td Middel
              tr
                td De back-end van de applicatie bevat documentatie over het gebruik van de API’s.
                td Hoog
              tr
                td De applicatie bevat documentatie over de gemaakte architectuurkeuze.
                td Hoog
              tr
                td
                  | De applicatie bevat documentatie op het gebied van integratie en communicatie tussen systemen en services.
                td Middel
              tr
                td
                  | De documentatie van de applicatie dient goedgekeurd te worden door het team dat de applicatie in onderhoud gaat nemen.
                td Middel
              tr
                td De documentatie van de API kan automatisch gegenereerd worden.
                td Laag
              tr
                td
                  | De gehele applicatie dient de data integriteit in de database(s) te bewaren.
                  | Dit betekent onder andere dat data in rust en in transport beveiligd dient te zijn (onleesbaar voor onbevoegde).
                td Hoog
        component-section
          div(slot='title') Randvoorwaarden
          p
          p
          table#table_randvoorwaarden
            caption
              | Randvoorwaarden
            thead
              tr
                th(scope='col') Omschrijving
                th(scope='col') Belang
            tbody
              tr
                td
                  | De applicatie moet voor de eindoplevering in de Microsoft Azure Cloud gehost worden binnen een productieomgeving
                td Hoog
              tr
                td
                  | De applicatie dient te worden ontwikkeld in een OTAP omgeving en uitleveringen gaan via het CD-principe.
                td Hoog
              tr
                td De applicatie dient een front-end te hebben die voldoet aan de HAN huisstijl.
                td Hoog
              tr
                td
                  | De applicatie dient een front-end te hebben die goedgekeurd dient te zijn door een UI/UX-designer van CMD.
                td Laag
              tr
                td
                  | De front-end dient aan het einde van elke sprint responsive zijn volgens de HAN web standaarden.
                td Middel
              tr
                td
                  | De front-end dient voor de eindoplevering te werken op smartphones en tablets (Samsung Galaxy reeks, iPhone reeks) vanaf 2018.
                td Hoog
              tr
                td
                  | De applicatie moet voor de eindoplevering voldoen aan de standaarden van de meest gebruikte web browsers (Chrome, Edge, Firefox, Safari).
                td Hoog
              tr
                td
                  | De applicatie dient te voldoen aan de privacywet AVG (Privacy en Security by Design).
                td Hoog
              tr
                td
                  | Het Minimum Viable Product dient minimaal aan de “Hoog” bestempelde functionele eisen te voldoen.
                td Hoog
        component-section
          div(slot='title') Ontwerpbeperkingen
          p
            | Deze beperkingen hebben betrekking op de kennis die aanwezig is binnen de HAN AIM.
          p
          table#table_ontwbeperking
            caption
              | Ontwerpbeperkingen
            thead
              tr
                th(scope='col') Omschrijving
                th(scope='col') Belang
            tbody
              tr
                td
                  | De back-end van de applicatie dient met Microsoft .NET 5.0 of hoger ontwikkeld te worden
                td Hoog
              tr
                td De backlog dient dagelijks vanaf sprint 0 te worden bijgehouden in Azure DevOps.
                td Hoog
              tr
                td
                  | De database(s) en de applicatie dienen gehost te worden in de Azure cloud en dienen zoveel mogelijk als SaaS te zijn ingericht.
                td Hoog
              tr
                td
                  | De ontwikkelaars maken tijdens de ontwikkeling van de applicatie alleen gebruik van door HAN goedgekeurde programma’s.
                td Hoog
              tr
                td Github wordt gebruikt als source control in combinatie met Azure Devops pipelines.
                td Hoog
              tr
                td
                  | De applicatie dient voor eindoplevering 2500 gebruikers te kunnen ondersteunen, waarvan 50 gelijktijdig.
                td Hoog
              tr
                td
                  | De front-end van de applicatie dient een webapplicatie te zijn.
                  | Deze kan ontwikkeld zijn in Angular, React of vergelijkbaar.
                  | PHP is niet toegestaan.
                td Hoog
